#ifndef TIMER_H
#define TIMER_H
//-
//- Der Timer versucht den Win32 HighPerformance Timer zu nutzen,
//- fall dieser nicht untersttzt wird, wird automatisch der Windows
//- Multimedia Timer verwendet.
//- Die Update() Funktions sollte einmal per Frame aufgerufen werden.

class CTimer
{
public:
	CTimer();
	~CTimer();

	void Init();
	void Reset();
	
	void Update();

	inline const float & GetCurrentTime() const { return m_fCurrentTime; }
	inline const float & GetFrameTime()   const { return m_fFrameTime;   } 

private:
	typedef float (CTimer::* TimeUpdateFunc) ();
	TimeUpdateFunc m_pfnUpdate;

	float	m_fBaseTime;
	float	m_fLastTime;
	float	m_fSecsPerTick;

	float	m_fCurrentTime;
	float	m_fFrameTime;

	_int64	m_dTimerStart;
	_int64  m_dCurTime;

	float	GetPerformanceCounterTime();
	float	GetMMTime();
};

#endif //- TIMER_H